###...........................................................................................................................
###.................................................................dddddddd..................................................
###.................................................................d::::::d..................1111111.........................
###.................................................................d::::::d.................1::::::1.........................
###.................................................................d::::::d................1:::::::1.........................
###.................................................................d:::::d.................111:::::1.........................
###.........................................................ddddddddd:::::drrrrr...rrrrrrrrr...1::::1..ppppp...ppppppppp......
###.......................................................dd::::::::::::::dr::::rrr:::::::::r..1::::1..p::::ppp:::::::::p.....
###......................................................d::::::::::::::::dr:::::::::::::::::r.1::::1..p:::::::::::::::::p....
###.....................................................d:::::::ddddd:::::drr::::::rrrrr::::::r1::::l..pp::::::ppppp::::::p...
###.....................................................d::::::d....d:::::d.r:::::r.....r:::::r1::::l...p:::::p.....p:::::p...
###.....................................................d:::::d.....d:::::d.r:::::r.....rrrrrrr1::::l...p:::::p.....p:::::p...
###.....................................................d:::::d.....d:::::d.r:::::r............1::::l...p:::::p.....p:::::p...
###.....................................................d:::::d.....d:::::d.r:::::r............1::::l...p:::::p....p::::::p...
###.....................................................d::::::ddddd::::::ddr:::::r.........111::::::111p:::::ppppp:::::::p...
###......................................................d:::::::::::::::::dr:::::r.........1::::::::::1p::::::::::::::::p....
###.......................................................d:::::::::ddd::::dr:::::r.........1::::::::::1p::::::::::::::pp.....
###........................................................ddddddddd...dddddrrrrrrr.........111111111111p::::::pppppppp.......
###.....................................................................................................p:::::p...............
###.....................................................................................................p:::::p...............
###....................................................................................................p:::::::p..............
###....................................................................................................p:::::::p..............
###....................................................................................................p:::::::p..............
###....................................................................................................ppppppppp..............
###...........................................................................................................................
##################################################################################################################### 07/24/21
import os
import requests
import random
from requests.exceptions import HTTPError
from urllib.request import Request, urlopen
from urllib.error import URLError, HTTPError
##############################################################################################################################
USER_AGENT_BROWSER="Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/51.0.2704.103 Safari/537.36"
STATUS_BAD_CODE=":( - error code: {}"
STATUS_BAD_REASON=":( - failed reason: {}"
STATUS_OK=":)"
LOGFILE="textart_dot_sh_db.txt"
LOGINIT=0
TEXTART_URL="https://textart.sh/{}"
##############################################################################################################################
class C_d:
    pass
##############################################################################################################################
def l0g(s):
    global LOGFILE; global LOGINIT;
    if not LOGINIT:
        if os.path.isfile(LOGFILE): os.remove(LOGFILE);
        f = open(LOGFILE,'w'); f.write(''); f.close(); LOGINIT=1;
    f = open(LOGFILE,'a'); f.write(f'{s}\n'); f.close(); print(s);
    return
##############################################################################################################################
def urlget(uri=""):
    url = f"https://textart.sh/{uri}"
    r = Request(url,data=None,headers={ 'User-Agent': USER_AGENT_BROWSER })
    try:
        response = urlopen(r,timeout=10).read().decode('utf-8')
    except HTTPError as e:
        return STATUS_BAD_CODE.format(e.code)
    except  URLError as e:
        return STATUS_BAD_REASON.format(e.reason)
    else:
        return STATUS_OK + response
##############################################################################################################################
def findall(s,w):
    return [i for i in range(len(s)) if s.startswith(w,i)]
##############################################################################################################################
def extract_data_from_response(RESPONSE, TOPIC):
    msg = 'TEXTART: parsing site item'; print(msg)
    _x=findall(RESPONSE.text,'var(--gallery-column-width))">');_y=findall(RESPONSE.text,'</pre>');_y.pop();_x=[x+30 for x in _x]
    for i in range(len(_x)):
        dr1p.db_topic.append(TOPIC)        
        dr1p.db_art.append(RESPONSE.text[_x[i]:_y[i]])
    return
##############################################################################################################################
def get_TEXTART(TOPIC, SESSION):
    url = TEXTART_URL.format(TOPIC[1:]); response = None
    try:
        response = SESSION.get(url)
        response.raise_for_status()
        msg = f"Response status {url}: {response.status_code}"; print(msg)
    except HTTPError as http_err:
        msg = f"HTTP error occurred: {http_err}"; print(msg)
    except Exception as err:
        msg = f"An error ocurred: {err}"; print(msg)
    return response
##############################################################################################################################
if __name__ == "__main__":
    dr1p = C_d()
    dr1p.db_art=[]
    dr1p.db_topic=[]
    dr1p.topics=[]
    RESPONSE=urlget('')
    _x=findall(RESPONSE,'<li><a href="/topic/')
    _y=findall(RESPONSE,'</span></a></li>')

    for i in range(len(_x)):
        dr1p.topics.append(RESPONSE[_x[i]:_y[i]].split('href="')[1].split('">')[0])

    with requests.Session() as SESSION:
        for TOPIC in dr1p.topics:
            try:
                RESPONSE = get_TEXTART(TOPIC, SESSION)
                parsed_response = extract_data_from_response(RESPONSE, TOPIC)
                msg = 'site item done'; print(msg)
            except Exception as err:
                msg = f'exception: requests.Session {err}'; print(msg)

    for i,artpiece in enumerate(dr1p.db_art):
        topic_color = __color('9'); art_color = __color(hex(random.randint(0,15))[2:])
        msg=f'index: {i+1}/{len(dr1p.db_topic)} - https://textart.sh/{dr1p.db_topic[i][1:]}'
        l0g(msg)
        for line in artpiece.splitlines():
            l0g(line)
        l0g('')
##############################################################################################################################
